SystemOrganization addCategory: #'NXTalk-Kernel'!
SystemOrganization addCategory: #'NXTalk-Building'!
SystemOrganization addCategory: #'NXTalk-Collections'!
SystemOrganization addCategory: #'NXTalk-Tests'!

!String methodsFor: '*nxtalk' stamp: 'mab 3/11/2008 01:09'!
printNl
	Transcript show: self; cr.! !

RBProgramNodeVisitor subclass: #NXTCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTCompiler class methodsFor: 'as yet unclassified' stamp: 'mab 4/6/2008 22:35'!
bytecodes
	^ Dictionary new
		at: #return put: 0;
		at: #send put: 1;
		at: #selfSend put: 2;
		at: #push put: 3;
		at: #pop put: 4;
		at: #halt put: 5;
		yourself! !

!NXTCompiler methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 02:19'!
compileMethod: methodString
	| ast |
	ast := RBParser parseMethod: methodString.
	self visitNode: ast.! !

!PositionableStream methodsFor: '*nxtalk' stamp: 'mab 4/12/2008 14:24'!
littleEndianWord
	self nextLittleEndianNumber: 2! !

!PositionableStream methodsFor: '*nxtalk' stamp: 'mab 4/12/2008 14:24'!
littleEndianWord: number
	self nextLittleEndianNumber: 2 put: number! !

Object subclass: #NXTImage
	instanceVariableNames: 'objects specialObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/25/2008 23:50'!
addObject: anNXTObject
	^  self objects add: anNXTObject! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 3/17/2008 16:57'!
initialize
	objects := OrderedCollection new.
	specialObjects := Dictionary new.
	idMapping := Dictionary new.! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/25/2008 23:38'!
metaclass
	^ self specialObjects at: #metaclass! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/25/2008 23:38'!
metaclass: aValue
	^ self specialObjects at: #metaclass put: aValue! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/20/2008 03:18'!
nil
	^ self specialObjects at: #nil! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/20/2008 03:18'!
nil: aValue
	^ self specialObjects at: #nil put: aValue! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:06'!
objects
	^ objects! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:06'!
objects: anObject
	objects := anObject! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:06'!
specialObjects
	^ specialObjects! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:06'!
specialObjects: anObject
	specialObjects := anObject! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/25/2008 23:25'!
systemDictionary
	^ self specialObjects at: #systemDictionary! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/25/2008 23:25'!
systemDictionary: aValue
	^ self specialObjects at: #systemDictionary put: aValue! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 4/12/2008 14:25'!
writeHeaderTo: aByteStream
	aByteStream littleEndianWord: 16r4242.
	aByteStream littleEndianWord: self objects size.! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 3/17/2008 17:12'!
writeObjectsTo: aByteStream withMapper: mapper
	self objects do: [ :each | each writeOn: aByteStream withMapper: mapper ].! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 4/12/2008 14:25'!
writeSpecialObjectsTo: aByteStream withMapper: mapper
	aByteStream littleEndianWord: (mapper idFor: (self specialObjects at: #System))! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 3/17/2008 17:13'!
writeToStream: aByteStream
	| mapper |
	mapper := NXTObjectMapper on: self objects.
	self writeHeaderTo: aByteStream.
	self writeObjectsTo: aByteStream withMapper: mapper.
	self writeSpecialObjectsTo: aByteStream withMapper: mapper.! !

Object subclass: #NXTImageBuilder
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTImageBuilder class methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 02:52'!
standardCategories
	^ #('NXTalk-Kernel' 'NXTalk-Collections')! !

!NXTImageBuilder class methodsFor: 'as yet unclassified' stamp: 'mab 2/26/2008 00:06'!
systemClasses
	^ #(objectClass nilClass classClass arrayClass symbolClass methodClass integerClass bigintegerClass frameClass stringClass doubleClass)! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 02:54'!
compileClass: aClass
	! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 03:00'!
compileClasses
	self class standardCategories do: [ :category |
		(Smalltalk organization listAtCategoryNamed: category) do: [ :class |
			self compileClass: class ]].! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/25/2008 23:53'!
createMetaclasses
	| metaclass |
	metaclass := self newClass.
	metaclass nxtClass: self newClass.
	"Metaclass class class = Metaclass"
	metaclass nxtClass nxtClass: metaclass.
	^ metaclass! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/26/2008 00:24'!
createSpecialObjects
	self image nil: self newObject.
	self image metaclass: self createMetaclasses.
	self createSystemClasses.
	self image nil nxtClass: (self image specialObjects at: #nilClass).
	self initializeSystemClasses.! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 03:06'!
createStandardImage
	self image: NXTImage new.
	self createSpecialObjects.
	self compileClasses.! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/26/2008 00:06'!
createSystemClasses
	self class systemClasses do: [ :symbol |
		self image specialObjects at: symbol put: self newSystemClass ].
	! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 4/7/2008 00:05'!
helloWorldImageOn: aByteStream
	| systemClass systemObject runMethodObject helloWorldMethodObject |
	self image: NXTImage new.
	systemClass := NXTImageObject new.
	self image addObject: systemClass.
	systemObject := NXTImageObject new.
	self image addObject: systemObject.
	self image specialObjects at: #System put: systemObject.
	helloWorldMethodObject := NXTImageObject new.
	helloWorldMethodObject isIndexable: true.
	self image addObject: helloWorldMethodObject.
	runMethodObject := NXTImageObject new.
	runMethodObject isIndexable: true.
	runMethodObject isByteArray: true.
	self image addObject: runMethodObject.
	systemObject nxtClass: systemClass.
	systemClass nxtClass: systemClass.
	systemClass instanceVariables add: runMethodObject.
	systemClass instanceVariables add: helloWorldMethodObject.
	"Run Method"
	runMethodObject nxtClass: systemClass.
	runMethodObject instanceVariables add: 1. "Literal count"
	runMethodObject instanceVariables add: (NXTCompiler bytecodes at: #selfSend) * 256.
	runMethodObject instanceVariables add: (NXTCompiler bytecodes at: #pop) * 256 + (NXTCompiler bytecodes at: #halt).
	runMethodObject instanceVariables add: 2.
	"helloWorld method primitive"
	helloWorldMethodObject nxtClass: systemClass.
	helloWorldMethodObject instanceVariables add: (16r8000 bitOr: 0).
	self image writeToStream: aByteStream.
! !

!NXTImageBuilder methodsFor: 'accessing' stamp: 'mab 2/20/2008 02:50'!
image
	^ image! !

!NXTImageBuilder methodsFor: 'accessing' stamp: 'mab 2/20/2008 02:50'!
image: anObject
	image := anObject! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/26/2008 00:39'!
initializeSystemClass: classSymbol superclass: superclassSymbol name: nameSymbol
	| class |
	class := self image specialObjects at: classSymbol.
	class nxtSuperclass: (self image specialObjects at: superclassSymbol).
	(self image specialObjects at: #Smalltalk) at: nameSymbol put: class.! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/26/2008 01:00'!
initializeSystemClasses
	self initializeSystemClass: #objectClass superclass: #nil name: #Object.
	self initializeSystemClass: #classClass superclass: #objectClass name: #Class.
	self initializeSystemClass: #metaclass superclass: #classClass name: #Metaclass.
	self initializeSystemClass: #nilClass superclass: #objectClass name: #UndefinedObject.
	self initializeSystemClass: #arrayClass superclass: #objectClass name: #Array.
	self initializeSystemClass: #methodClass superclass: #arrayClass name: #Method.
	self initializeSystemClass: #symbolClass superclass: #objectClass name: #Symbol.! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/25/2008 23:52'!
newClass
	^  self image addObject: NXTImageClass new! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/25/2008 23:52'!
newObject
	^  self image addObject: NXTImageObject new! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/25/2008 23:56'!
newSystemClass
	| systemClass |
	systemClass := self newClass.
	systemClass nxtClass: self newClass.
	systemClass nxtClass nxtClass: self image metaclass.
	^ systemClass! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/25/2008 23:36'!
objectForClass: anNXTClass
	| class |
	class := NXTImageClass new.
	class nxtClass: self newMetaclass.
	
	^ class! !

!NXTImageBuilder methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:17'!
specialObjects
	^ self image specialObjects! !

Object subclass: #NXTImageObject
	instanceVariableNames: 'nxtClass instanceVariables isIndexable isByteArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

NXTImageObject subclass: #NXTImageClass
	instanceVariableNames: 'methodDictionary instanceVariableNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTImageObject methodsFor: 'as yet unclassified' stamp: 'mab 4/7/2008 00:04'!
header
	| header |
	header := self instanceVariables size.
	self isIndexable ifTrue: [ header := header bitOr: 16r8000 ].
	self isByteArray ifTrue: [ header := header bitOr: 16r4000 ].
	^ header! !

!NXTImageObject methodsFor: 'as yet unclassified' stamp: 'mab 2/25/2008 23:05'!
initialize
	instanceVariables := OrderedCollection new.! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:03'!
instanceVariables
	^ instanceVariables! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:03'!
instanceVariables: anObject
	instanceVariables := anObject! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 4/7/2008 00:05'!
isByteArray
	^ isByteArray ifNil: [ isByteArray := false ]! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 4/7/2008 00:04'!
isByteArray: anObject
	isByteArray := anObject! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 3/17/2008 17:58'!
isIndexable
	^ isIndexable ifNil: [ isIndexable := false ]! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 3/17/2008 17:58'!
isIndexable: anObject
	isIndexable := anObject! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:04'!
nxtClass
	^ nxtClass! !

!NXTImageObject methodsFor: 'accessing' stamp: 'mab 2/20/2008 03:04'!
nxtClass: anObject
	nxtClass := anObject! !

!NXTImageObject methodsFor: 'as yet unclassified' stamp: 'mab 4/12/2008 15:41'!
writeOn: aByteStream withMapper: mapper
	aByteStream littleEndianWord: self header.
	aByteStream littleEndianWord: (mapper idFor: self nxtClass).
	self instanceVariables do: [ :instanceVariable |
		self isIndexable 
			ifFalse: [ aByteStream littleEndianWord: (mapper idFor: instanceVariable) ]
			"This is wrong and only works with numbers"
			ifTrue: [ aByteStream littleEndianWord: instanceVariable ]]! !

Object subclass: #NXTObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTObject subclass: #NXTArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTArray subclass: #NXTCompiledMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTObject subclass: #NXTBoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTBoolean subclass: #NXTFalse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTBoolean subclass: #NXTTrue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTObject subclass: #NXTClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTObject subclass: #NXTCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Collections'!

NXTObject subclass: #NXTMetaclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTObject subclass: #NXTString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

!NXTString methodsFor: 'as yet unclassified' stamp: 'mab 3/11/2008 01:09'!
printNl
	<primitive: 500>! !

NXTString subclass: #NXTSymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

NXTObject subclass: #NXTSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

!NXTSystem methodsFor: 'as yet unclassified' stamp: 'mab 3/22/2008 22:31'!
helloWorld
	<primitive: 0>! !

!NXTSystem methodsFor: 'as yet unclassified' stamp: 'mab 3/22/2008 22:31'!
run
	self helloWorld! !

NXTObject subclass: #NXTUndefinedObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Kernel'!

Object subclass: #NXTObjectMapper
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTObjectMapper class methodsFor: 'as yet unclassified' stamp: 'mab 3/17/2008 17:15'!
on: objectList
	^ self new objects: objectList! !

!NXTObjectMapper methodsFor: 'as yet unclassified' stamp: 'mab 3/17/2008 17:34'!
idFor: anObject
	^ (self objects indexOf: anObject) - 1! !

!NXTObjectMapper methodsFor: 'accessing' stamp: 'mab 3/17/2008 17:15'!
objects
	^ objects! !

!NXTObjectMapper methodsFor: 'accessing' stamp: 'mab 3/17/2008 17:15'!
objects: anObject
	objects := anObject! !

TestCase subclass: #NXTObjectMapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Tests'!
